/*
 *                            *
 *                           * *
 *                          *   *
 *                     ***************
 *                      * *       * *
 *                       *  MUMPS  *
 *                      * *       * *
 *                     ***************
 *                          *   *
 *                           * *
 *                            *
 *
 *   jnldefs.h
 *    Data structures and constants for journaling
 *
 *  
 *   Author: John P. Willis <jpw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2020 Coherent Logic Development LLC
 * 
 **/

#define FRM_JNL_VERSION 1

#define JNLA_TSTART 0
#define JNLA_TRESTART 1
#define JNLA_TROLLBACK 2
#define JNLA_TCOMMIT 3
#define JNLA_SET 4
#define JNLA_KILL 5

typedef struct jnl_hdr_t {
    char magic[5]; 		/* FRMJL */
    short fmt_version; 	/* FRM_JNL_VERSION */
} jnl_hdr_t;

typedef struct jnl_ent_t {

    char host_id[256];
    unsigned long tran_id;

    time_t ts; /* timestamp */
    pid_t pid;

    short action; /* can be any of the JNLA_ constants defined in journal.h */

    char key[1024];
    char data[1024];

} jnl_ent_t;