/*
 *                            *
 *                           * *
 *                          *   *
 *                     ***************
 *                      * *       * *
 *                       *  MUMPS  *
 *                      * *       * *
 *                     ***************
 *                          *   *
 *                           * *
 *                            *
 *
 *   journal.h
 *    Function prototypes, structs, and macros for FreeM
 *    journaling implementation
 *
 *  
 *   Author: John P. Willis <jpw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2020 Coherent Logic Development LLC
 * 
 **/


#ifndef _JOURNAL_H
# define _JOURNAL_H

#include <time.h>
#include <limits.h>

#if !defined(PATH_MAX) && defined(_SCO_DS)
# define PATH_MAX 4096
#endif

#if !defined(PATH_MAX) && defined(__gnu_hurd__)
# define PATH_MAX 1024
#endif

#if defined(__NetBSD__) || defined(__FreeBSD__) || defined(__OpenBSD__)
# include <sys/syslimits.h>
#endif

#include "jnldefs.h"

extern short jnl_enabled;

extern short jnl_init(char *jnlfile, char *hostid, unsigned long jnl_cut_threshold, unsigned long tran_id);
extern short jnl_ent_init(jnl_ent_t *entry);
extern short jnl_ent_write(short action, char *key, char *data);

#endif

