/*
 *                            *
 *                           * *
 *                          *   *
 *                     ***************
 *                      * *       * *
 *                       *  MUMPS  *
 *                      * *       * *
 *                     ***************
 *                          *   *
 *                           * *
 *                            *
 *
 *   ssvn_event.c
 *    ^$EVENT ssvn
 *
 *  
 *   Author: John P. Willis <jpw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2020 Coherent Logic Development LLC
 *
 **/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "freem.h"
#include "mref.h"
#include "mpsdef.h"

void ssvn_event(short action, char *key, char *data)
{

	freem_ref_t *ref = (freem_ref_t *) malloc (sizeof(freem_ref_t));
	char *kbuf = (char *) malloc (STRLEN * sizeof(char));

	stcpy (kbuf, key);

    mref_init (ref, MREF_RT_SSVN, "");
    internal_to_mref (ref, key);

    switch (action) {
    
    	case new_sym:
        case get_sym:         
        case set_sym:   
        case killone:
        case kill_sym:     
        case dat:
        case order:
        case query:
        case bigquery:
        case getnext:
        case m_alias:
        case zdata:

        	symtab (action, kbuf, data);

        	free (kbuf);
        	free (ref);

        	ierr = OK;
        	return;
            
        default:
            ierr = INVREF;
            return;

    }


    *data = EOL;
    return;
}